"""
MCP Mesh Agent API

API contract for MCP Mesh Agent HTTP endpoints.  ⚠️  CRITICAL FOR AI DEVELOPERS: This OpenAPI specification defines the AGENT-SIDE CONTRACT for Python agent HTTP wrappers.  🤖 AI BEHAVIOR RULES: - NEVER modify this spec without explicit user approval - This is SEPARATE from the registry API contract - Only applies to Python agent HTTP wrapper endpoints - Used for agent-to-external and agent health monitoring  📋 Scope: - Agent health and readiness endpoints - Agent capability and tool discovery - Agent metrics and monitoring - MCP protocol HTTP transport

The version of the OpenAPI document: 1.0.0
Contact: dhyanraj@gmail.com
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from fastapi import FastAPI
from mcp_mesh_agent_server.apis.health_api import router as HealthApiRouter
from mcp_mesh_agent_server.apis.mcp_api import router as McpApiRouter
from mcp_mesh_agent_server.apis.mesh_api import router as MeshApiRouter
from mcp_mesh_agent_server.apis.monitoring_api import router as MonitoringApiRouter

app = FastAPI(
    title="MCP Mesh Agent API",
    description="API contract for MCP Mesh Agent HTTP endpoints.  ⚠️  CRITICAL FOR AI DEVELOPERS: This OpenAPI specification defines the AGENT-SIDE CONTRACT for Python agent HTTP wrappers.  🤖 AI BEHAVIOR RULES: - NEVER modify this spec without explicit user approval - This is SEPARATE from the registry API contract - Only applies to Python agent HTTP wrapper endpoints - Used for agent-to-external and agent health monitoring  📋 Scope: - Agent health and readiness endpoints - Agent capability and tool discovery - Agent metrics and monitoring - MCP protocol HTTP transport ",
    version="1.0.0",
)

app.include_router(HealthApiRouter)
app.include_router(McpApiRouter)
app.include_router(MeshApiRouter)
app.include_router(MonitoringApiRouter)
